<template>
	<div class="statistics-order-specials-container layout-pd">
		<!-- 搜索  -->
		<el-card shadow="never">
			<el-form :model="state.queryParams" ref="ruleFormRef" @submit.native.prevent inline>
				<el-form-item label="时间段" prop="crTime">
					<el-date-picker
						v-model="state.queryParams.crTime"
						type="datetimerange"
						unlink-panels
						range-separator="至"
						start-placeholder="开始时间"
						end-placeholder="结束时间"
						:shortcuts="shortcuts"
						@change="queryList"
						value-format="YYYY-MM-DD[T]HH:mm:ss"
					/>
				</el-form-item>
				<el-form-item>
					<el-button type="primary" @click="queryList" :loading="state.loading"> <SvgIcon name="ele-Search" class="mr5" />查询 </el-button>
					<el-button @click="resetQuery(ruleFormRef)" class="default-button" :loading="state.loading">
						<SvgIcon name="ele-Refresh" class="mr5" />重置
					</el-button>
				</el-form-item>
			</el-form>
		</el-card>
		<el-card shadow="never">
			<ProTable
				ref="proTableRef"
				:columns="columns"
				:data="state.tableData"
				@updateTable="queryList"
				:loading="state.loading"
				border
				:total="state.total"
				v-model:page-index="state.queryParams.PageIndex"
				v-model:page-size="state.queryParams.PageSize"
			>
				<template #orderNum="{ row }">
					<el-button link @click="handleDetail(row)" type="primary">{{ row.orderNum }}</el-button>
				</template>
			</ProTable>
		</el-card>
	</div>
</template>
<script setup lang="tsx" name="statisticsOrderSpecial">
import { onMounted, reactive, ref } from 'vue';
import { ElButton, FormInstance } from 'element-plus';
import { throttle } from '@/utils/tools';
import { departmentSpecial } from '@/api/statistics/order';
import { shortcuts } from '@/utils/constants';
import dayjs from 'dayjs';
import { formatDate } from '@/utils/formatTime';
import { useRouter } from 'vue-router';

// 表格配置项
const columns = ref<any[]>([
	{ type: 'index', fixed: 'left', width: 55, label: '序号', align: 'center' },
	{ prop: 'cause', label: '特提原因', align: 'center' },
	{ prop: 'orderNum', label: '特提工单数', align: 'center' },
	{
		prop: 'passTotal',
		label: '特提时间',
		align: 'center',
		render: (scope) => <span>{formatDate(scope.row.maxSpecialTime, 'YYYY-mm-dd HH:MM:SS')}</span>,
	},
]);
// 定义变量内容
const ruleFormRef = ref<RefType>(); // 表单ref
const state = reactive({
	queryParams: {
		// 查询条件
		PageIndex: 1, // 页码
		PageSize: 10, // 每页条数
		crTime: [dayjs().startOf('day').format('YYYY-MM-DD HH:mm:ss'), dayjs().endOf('day').format('YYYY-MM-DD HH:mm:ss')], // 时间默认今天开始到今天结束
	},
	tableData: [], //表单
	loading: false, // 加载
	total: 0, // 总数
});
/** 获取列表 */
const queryList = throttle(() => {
	state.loading = true;
	let StartTime = null;
	let EndTime = null;
	if (state.queryParams?.crTime) {
		StartTime = state.queryParams?.crTime[0];
		EndTime = state.queryParams?.crTime[1];
	}
	const request = {
		StartTime,
		EndTime,
		PageIndex: state.queryParams.PageIndex,
		PageSize: state.queryParams.PageSize,
	};
	departmentSpecial(request)
		.then((res: any) => {
			state.tableData = res.result?.items ?? [];
			state.total = res.result?.total ?? 0;
			state.loading = false;
		})
		.catch(() => {
			state.loading = false;
		});
}, 300);
/** 重置按钮操作 */
const resetQuery = throttle((formEl: FormInstance | undefined) => {
	if (!formEl) return;
	formEl.resetFields();
	queryList();
}, 300);
const router = useRouter();
const handleDetail = (row: any) => {
	let startTime = null;
	let endTime = null;
	if (state.queryParams?.crTime) {
		startTime = state.queryParams?.crTime[0];
		endTime = state.queryParams?.crTime[1];
	}
	router.push({
		name: 'statisticsOrderSpecialTable',
		params: {
			cause: row.cause,
			startTime: startTime ?? 'null',
			endTime: endTime ?? 'null',
			tagsViewName: `特提统计明细(${row.cause})`,
		},
	});
};
onMounted(() => {
	queryList();
});
</script>
